VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDIBPic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const OBJ_BITMAP          As Long = 7
Private Const DIB_RGB_COLORS      As Long = 0

Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type BITMAP
    bmType       As Long
    bmWidth      As Long
    bmHeight     As Long
    bmWidthBytes As Long
    bmPlanes     As Integer
    bmBitsPixel  As Integer
    bmBits       As Long
End Type

Private Const COLORONCOLOR        As Long = 3
Private Const HALFTONE            As Long = 4
Public Enum eStretchBltModeCts
    [sbmColorOnColor] = COLORONCOLOR
    [sbmHalftone] = HALFTONE
End Enum

'Create -- Set backColor  *******************************
Private Type RECT
    x1 As Long
    y1 As Long
    x2 As Long
    y2 As Long
End Type

Private Declare Function SetRect Lib "user32" ( _
             lpRect As RECT, ByVal x1 As Long, _
             ByVal y1 As Long, ByVal x2 As Long, _
             ByVal y2 As Long) As Long
    
Private Declare Function FillRect Lib "user32" ( _
             ByVal hDC As Long, lpRect As RECT, _
             ByVal hBrush As Long) As Long
    
Private Declare Function CreateSolidBrush Lib "gdi32" ( _
    ByVal crColor As Long) As Long
    
Private m_BackColor As OLE_COLOR

'**********************************************************

Private Declare Function CreateDIBSection Lib "gdi32" ( _
       ByVal hDC As Long, lpBitsInfo As BITMAPINFOHEADER, _
       ByVal wUsage As Long, lpBits As Long, _
       ByVal handle As Long, ByVal dw As Long) As Long
       
Private Declare Function GetObjectType Lib "gdi32" ( _
       ByVal hgdiobj As Long) As Long
       
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" ( _
       ByVal hObject As Long, ByVal nCount As Long, _
       lpObject As Any) As Long
       
Private Declare Function CreateCompatibleDC Lib "gdi32" ( _
       ByVal hDC As Long) As Long
       
Private Declare Function SelectObject Lib "gdi32" ( _
       ByVal hDC As Long, ByVal hObject As Long) As Long
       
Private Declare Function BitBlt Lib "gdi32" (ByVal hDC As Long, _
        ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, _
        ByVal nHeight As Long, ByVal hSrcDC As Long, _
        ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long _
        ) As Long
        
Private Declare Function DeleteDC Lib "gdi32" ( _
       ByVal hDC As Long) As Long

Private Declare Function DeleteObject Lib "gdi32" ( _
       ByVal hObject As Long) As Long
       
Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, _
       ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, _
       ByVal nHeight As Long, ByVal hSrcDC As Long, _
       ByVal xSrc As Long, ByVal ySrc As Long, _
       ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, _
       ByVal dwRop As Long) As Long
Private Declare Function SetStretchBltMode Lib "gdi32" ( _
       ByVal hDC As Long, ByVal nStretchMode As Long) As Long

Private Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" ( _
       lpDst As Any, ByVal Length As Long)

Private m_uBIH    As BITMAPINFOHEADER
Private m_hDC     As Long
Private m_hDIB    As Long
Private m_hOldDIB As Long
Private m_lpBits  As Long

Public Function CreateFromStdPicture(Image As StdPicture, _
                Optional ByVal BackColor As Long = vbBlack) As Long

  Dim uBI      As BITMAP
  Dim lhDC     As Long
  Dim lhOldBmp As Long
    
    If (Not Image Is Nothing) Then

        If (GetObjectType(Image.handle) = OBJ_BITMAP) Then
        
            Call GetObject(Image.handle, Len(uBI), uBI)
            
            If (Create(uBI.bmWidth, uBI.bmHeight, BackColor)) Then
                lhDC = CreateCompatibleDC(0)
                If (lhDC <> 0) Then
                    lhOldBmp = SelectObject(lhDC, Image.handle)
                    
                    '-- Load uBits
                    Call BitBlt(m_hDC, 0, 0, uBI.bmWidth, _
                           uBI.bmHeight, lhDC, 0, 0, vbSrcCopy)
                   
                    '--  Temp. DC freigeben
                    Call SelectObject(lhDC, lhOldBmp)
                    Call DeleteDC(lhDC)
                    
                    '-- ausgeben
                    CreateFromStdPicture = m_hDIB
                End If
            End If
        End If
    End If
End Function

Public Function Create(ByVal NewWidth As Long, _
                       ByVal NewHeight As Long, _
              Optional ByVal BackColor As Long = vbBlack _
              ) As Long
                      
    Dim uRect  As RECT
    Dim hBrush As Long
    
    '-- BackColor Farbe einlesen
    m_BackColor = BackColor
    
    '-- Geladene DIB freigeben
    Call Me.Destroy
    
    '-- Header einlesen
    With m_uBIH
        .biSize = Len(m_uBIH)
        .biPlanes = 1
        .biBitCount = 32
        .biWidth = NewWidth
        .biHeight = NewHeight
        .biSizeImage = 4 * NewWidth * NewHeight
    End With
    
    '-- Create DIB section
    m_hDC = CreateCompatibleDC(0)
    If (m_hDC <> 0) Then
        '-- Create DIB
        m_hDIB = CreateDIBSection(m_hDC, m_uBIH, _
                       DIB_RGB_COLORS, m_lpBits, 0, 0)
        If (m_hDIB <> 0) Then
            '-- Select DC
           m_hOldDIB = SelectObject(m_hDC, m_hDIB)
           '-- Set BackColor
           Call SetRect(uRect, 0, 0, NewWidth, NewHeight)
           hBrush = CreateSolidBrush(BackColor)
           Call FillRect(m_hDC, uRect, hBrush)
           Call DeleteObject(hBrush)
        Else
           Call Me.Destroy
        End If
    End If
    
    '-- Ausgabe
    Create = m_hDIB
End Function

Public Function Paint(ByVal hDC As Long, _
             Optional ByVal x As Long = 0, _
             Optional ByVal y As Long = 0, _
             Optional ByVal ROP As RasterOpConstants = vbSrcCopy _
             ) As Long
       
      With m_uBIH
         Paint = StretchBlt(hDC, x, y, .biWidth, .biHeight, _
                    m_hDC, 0, 0, .biWidth, .biHeight, vbSrcCopy)
      End With
End Function

Public Sub LoadBlt(ByVal hSrcDC As Long, _
          Optional ByVal x As Long = 0, _
          Optional ByVal y As Long = 0)
    If (Me.hDIB <> 0) Then
        Call BitBlt(m_hDC, 0, 0, m_uBIH.biWidth, _
           m_uBIH.biHeight, hSrcDC, x, y, vbSrcCopy)
    End If
End Sub

Public Function Stretch(ByVal hDC As Long, _
       ByVal x As Long, ByVal y As Long, _
       ByVal nWidth As Long, ByVal nHeight As Long, _
       Optional ByVal xSrc As Long, _
       Optional ByVal ySrc As Long, _
       Optional ByVal nSrcWidth As Long, _
       Optional ByVal nSrcHeight As Long, _
       Optional ByVal ROP As RasterOpConstants = vbSrcCopy, _
       Optional ByVal StretchBltMode _
       As eStretchBltModeCts = [sbmColorOnColor]) As Long
  
  Dim lOldMode As Long
    
    If (m_hDIB <> 0) Then
        
        If (nSrcWidth = 0) Then nSrcWidth = m_uBIH.biWidth
        If (nSrcHeight = 0) Then nSrcHeight = m_uBIH.biHeight
        lOldMode = SetStretchBltMode(hDC, StretchBltMode)
        Stretch = StretchBlt(hDC, x, y, nWidth, nHeight, m_hDC, xSrc, _
                                      ySrc, nSrcWidth, nSrcHeight, ROP)
        Call SetStretchBltMode(hDC, lOldMode)
    End If

End Function

Public Sub Destroy()

    '-- DIB freigeben
    If (m_hDC <> 0) Then
        If (m_hDIB <> 0) Then
            Call SelectObject(m_hDC, m_hOldDIB)
            Call DeleteObject(m_hDIB)
        End If
        Call DeleteDC(m_hDC)
    End If
    
    '-- uBIH Structure zurcksetzen
    Call ZeroMemory(m_uBIH, Len(m_uBIH))
    
    '-- DIB Variablen zurcksetzen
    m_hDC = 0
    m_hDIB = 0
    m_hOldDIB = 0
    m_lpBits = 0
End Sub


'-- Properties
Public Property Get hDC() As Long
    hDC = m_hDC
End Property

Public Property Get hDIB() As Long
    hDIB = m_hDIB
End Property

Public Property Get Width() As Long
    Width = m_uBIH.biWidth
End Property

Public Property Get Height() As Long
    Height = m_uBIH.biHeight
End Property

Public Property Get lpBits() As Long
    lpBits = m_lpBits
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    m_BackColor = New_BackColor
End Property


Public Sub GetBestFitInfo(ByVal SrcW As Long, ByVal SrcH As Long, _
                          ByVal DstW As Long, ByVal DstH As Long, _
                          bfx As Long, bfy As Long, _
                          bfW As Long, bfH As Long, _
                          Optional ByVal StretchFit As Boolean = False)
                          
  Dim cW As Single
  Dim cH As Single
    
    If ((SrcW > DstW Or SrcH > DstH) Or StretchFit) Then
        cW = DstW / SrcW
        cH = DstH / SrcH
        If (cW < cH) Then
            bfW = DstW
            bfH = SrcH * cW
          Else
            bfH = DstH
            bfW = SrcW * cH
        End If
      Else
        bfW = SrcW
        bfH = SrcH
    End If
    bfx = (DstW - bfW) \ 2
    bfy = (DstH - bfH) \ 2
End Sub




